- name: Prepare SSL key log file and set environment variable globally
  ansible.builtin.blockinfile:
    path: "{{ project_directory }}/sslkeylog.sh"
    block: |
      export SSLKEYLOGFILE={{ ssl_key_logfile_path }}
    create: yes
  become: true

- name: Verify SSL key log file environment variable
  ansible.builtin.shell: |
    source {{project_directory}}/sslkeylog.sh
    printenv SSLKEYLOGFILE
  args:
    chdir: "{{ project_directory }}"
  register: env_var_check
  become: true
  ignore_errors: true

- name: Print environment variable check result
  ansible.builtin.debug:
    msg: |
      SSLKEYLOGFILE is set to:
        STDOUT: {{ env_var_check.stdout }}
        STDERR: {{ env_var_check.stderr }}

- name: Start Client Application with Environment Variable
  ansible.builtin.shell: |
    touch {{ssl_key_logfile_path}}
    source {{project_directory}}/sslkeylog.sh
    nohup {{ project_directory }}/venv/bin/python3 {{ project_directory }}/src/client/python/main.py en {{ server_ip }} > /dev/null 2>&1 &
  args:
    chdir: "{{ project_directory }}"
  poll: 0
  register: client_app_task

- name: Display output of start command
  ansible.builtin.debug:
    var: client_app_task.stdout_lines

- name: Wait for the client to start
  pause:
    seconds: 2

- name: Check if Client process is running
  ansible.builtin.shell: pgrep -f {{ project_directory }}/venv/bin/python3
  register: cli_process_check
  failed_when: cli_process_check.rc != 0

- name: Print the pgrep result
  ansible.builtin.debug:
    msg: |
      client process pgrep result:
        STDOUT: {{ cli_process_check.stdout_lines }}
        STDERR: {{ cli_process_check.stderr_lines }}
